"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultSettings = exports.defaultTranslations = void 0;
var react_1 = __importDefault(require("react"));
var mode_1 = require("./../const/mode");
// import { defaultTranslations as defaultImageUploadTranslations } from '@react-page/editor/lib/ui/ImageUpload/defaultTranslations';
exports.defaultTranslations = {
    // Strings used in ImageUpload module
    buttonContent: 'Choose for upload',
    noFileError: 'No file selected',
    badExtensionError: 'Wrong file type',
    tooBigError: 'Image file > 5MB',
    uploadingError: 'Error while uploading',
    unknownError: 'Unknown error',
    imageMode: 'Image',
    colorMode: 'Single color',
    gradientMode: 'Gradient color',
    lighten: 'Lighten',
    darken: 'Darken',
    usePadding: 'Use inner padding',
    onOff: 'Turn on settings on this panel',
    gradientRotation: 'Gradient rotation',
    degrees: 'deg',
    gradientOpacity: 'Gradient opacity',
    addColor: 'Add color',
    addGradient: 'Add a gradient',
    pluginName: 'Background',
    pluginDescription: 'Add background color, image or gradient',
    or: 'OR',
    haveUrl: 'Existing image URL',
    srcPlaceholder: 'http://example.com/image.png',
    imageUrl: 'Image URL',
    isParallax: 'Use parallax effect',
};
exports.defaultSettings = {
    defaultBackgroundColor: { r: 245, g: 0, b: 87, a: 1 },
    defaultGradientColor: { r: 245, g: 0, b: 87, a: 1 },
    defaultGradientSecondaryColor: { r: 71, g: 245, b: 87, a: 1 },
    defaultMode: 1,
    defaultModeFlag: 1,
    defaultDarken: 0.1,
    defaultLighten: 0,
    defaultHasPadding: true,
    defaultIsParallax: true,
    translations: exports.defaultTranslations,
    enabledModes: mode_1.IMAGE_MODE_FLAG | mode_1.COLOR_MODE_FLAG | mode_1.GRADIENT_MODE_FLAG,
    Controls: function () { return react_1.default.createElement(react_1.default.Fragment, null, " Controls for this plugin were not provided"); },
    Renderer: function () { return react_1.default.createElement(react_1.default.Fragment, null, "Renderer; for this plugin was not provided "); },
    cellStyle: {
        padding: 0,
    },
};
//# sourceMappingURL=settings.js.map